VERSION 5.00
Begin VB.UserControl IconTextBox 
   ClientHeight    =   1410
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4575
   ScaleHeight     =   1410
   ScaleWidth      =   4575
   Begin VB.PictureBox picIcon 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   230
      Left            =   30
      ScaleHeight     =   225
      ScaleWidth      =   225
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   30
      Width           =   230
   End
   Begin VB.TextBox txtText 
      Height          =   290
      Left            =   0
      TabIndex        =   0
      TabStop         =   0   'False
      Text            =   "     IconTextBox"
      Top             =   0
      Width           =   4575
   End
End
Attribute VB_Name = "IconTextBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Event IconClick()
Public Event IconDblClick()
Public Event Click()
Public Event DblClick()
Public Event Change()
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)

Private Sub picIcon_Click()
   txtText.SetFocus
   
   RaiseEvent IconClick
End Sub

Private Sub picIcon_DblClick()
   RaiseEvent IconDblClick
End Sub

Private Sub txtText_Change()
   If Len(txtText.Text) <= 6 Then txtText.SelStart = 6
   
   RaiseEvent Change
End Sub

Private Sub txtText_Click()
   If txtText.SelStart < 6 Then txtText.SelStart = 6
   
   RaiseEvent Click
End Sub

Private Sub txtText_DblClick()
   If txtText.SelStart < 6 Then txtText.SelStart = 6
   
   RaiseEvent DblClick
End Sub

Private Sub txtText_KeyDown(KeyCode As Integer, Shift As Integer)
   Dim OriginalKeyCode As Integer
   
   OriginalKeyCode = KeyCode
   
   If Len(txtText.Text) <= 6 Or txtText.SelStart < 6 Then
      txtText.SelStart = 6
      KeyCode = 0
   Else
      If txtText.SelStart < 6 Then
         txtText.SelStart = 6
      End If
   End If
   
   RaiseEvent KeyDown(OriginalKeyCode, Shift)
End Sub

Private Sub txtText_KeyPress(KeyAscii As Integer)
   Dim OriginalKeyAscii As Integer
   
   OriginalKeyAscii = KeyAscii

   If txtText.SelStart <= 6 And KeyAscii = 8 Then KeyAscii = 0
   If Len(txtText.Text) < 6 Or txtText.SelStart < 6 Then
      txtText.SelStart = 6
      KeyAscii = 0
   Else
      If txtText.SelStart < 6 Then
         txtText.SelStart = 6
         KeyAscii = 0
      End If
   End If
   
   RaiseEvent KeyPress(OriginalKeyAscii)
End Sub

Private Sub txtText_KeyUp(KeyCode As Integer, Shift As Integer)
   Dim OriginalKeyCode As Integer
   
   OriginalKeyCode = KeyCode
   
   If Len(txtText.Text) <= 6 Or txtText.SelStart < 6 Then
      txtText.SelStart = 6
      KeyCode = 0
   Else
      If txtText.SelStart < 6 Then
         txtText.SelStart = 6
      End If
   End If
   
   RaiseEvent KeyUp(OriginalKeyCode, Shift)
End Sub

Private Sub UserControl_Initialize()
   txtText.Text = Space(6) & UserControl.Name
   txtText.SelStart = 6
End Sub

Private Sub UserControl_Resize()
   UserControl.Height = 290
   txtText.Width = UserControl.Width
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Text", txtText.Text, "      ")
    Call PropBag.WriteProperty("CausesValidation", txtText.CausesValidation, True)
    Call PropBag.WriteProperty("BackColor", txtText.BackColor, &H80000005)
    Call PropBag.WriteProperty("Enabled", txtText.Enabled, True)
    Call PropBag.WriteProperty("ForeColor", txtText.ForeColor, &H80000008)
    Call PropBag.WriteProperty("Font", txtText.Font, Ambient.Font)
    Call PropBag.WriteProperty("MousePointer", txtText.MousePointer, 0)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MaxLength", txtText.MaxLength, 0 + 6) 'add six for the padding spaces
    Call PropBag.WriteProperty("Locked", txtText.Locked, False)
    Call PropBag.WriteProperty("PasswordChar", txtText.PasswordChar, "")
    Call PropBag.WriteProperty("ToolTipText", txtText.ToolTipText, "")
    Call PropBag.WriteProperty("SelText", txtText.SelText, "")
    Call PropBag.WriteProperty("SelStart", txtText.SelStart, 0)
    Call PropBag.WriteProperty("SelLength", txtText.SelLength, 0)
    
    Call PropBag.WriteProperty("Icon", Icon, Nothing)
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    txtText.Text = PropBag.ReadProperty("Text", "      ")
    txtText.CausesValidation = PropBag.ReadProperty("CausesValidation", True)
    txtText.BackColor = PropBag.ReadProperty("BackColor", &H80000005)
    txtText.Enabled = PropBag.ReadProperty("Enabled", True)
    txtText.ForeColor = PropBag.ReadProperty("ForeColor", &H80000008)
    Set txtText.Font = PropBag.ReadProperty("Font", Ambient.Font)
    txtText.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    txtText.MaxLength = PropBag.ReadProperty("MaxLength", 0 + 6) 'add six for the padding spaces
    txtText.Locked = PropBag.ReadProperty("Locked", False)
    txtText.PasswordChar = PropBag.ReadProperty("PasswordChar", "")
    txtText.ToolTipText = PropBag.ReadProperty("ToolTipText", "")
    txtText.SelText = PropBag.ReadProperty("SelText", "")
    txtText.SelStart = PropBag.ReadProperty("SelStart", 0)
    txtText.SelLength = PropBag.ReadProperty("SelLength", 0)
    
    Set Icon = PropBag.ReadProperty("Icon", Nothing)
End Sub

Public Property Get Text() As String
    Text = Right$(txtText.Text, Len(txtText.Text) - 6)
End Property

Public Property Let Text(ByVal New_Text As String)
    txtText.Text() = Space(6) & New_Text
    PropertyChanged "Text"
End Property

Public Property Get CausesValidation() As Boolean
    CausesValidation = txtText.CausesValidation
End Property

Public Property Let CausesValidation(ByVal New_CausesValidation As Boolean)
    txtText.CausesValidation() = New_CausesValidation
    PropertyChanged "CausesValidation"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = txtText.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    txtText.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

Public Property Get Enabled() As Boolean
    Enabled = txtText.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    txtText.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = txtText.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    txtText.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

Public Property Get Font() As Font
    Set Font = txtText.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set txtText.Font = New_Font
    PropertyChanged "Font"
End Property

Public Property Get MousePointer() As Integer
    MousePointer = txtText.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As Integer)
    txtText.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

Public Property Get MouseIcon() As Picture
    Set MouseIcon = txtText.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set txtText.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

Public Property Get MaxLength() As Long
    MaxLength = txtText.MaxLength - 6 'remove 6 to offset padding
End Property

Public Property Let MaxLength(ByVal New_MaxLength As Long)
    txtText.MaxLength() = New_MaxLength + 6 'add six to allow for padding space
    PropertyChanged "MaxLength"
End Property

Public Property Get Locked() As Boolean
    Locked = txtText.Locked
End Property

Public Property Let Locked(ByVal New_Locked As Boolean)
    txtText.Locked() = New_Locked
    PropertyChanged "Locked"
End Property

Public Property Get PasswordChar() As String
    PasswordChar = txtText.PasswordChar
End Property

Public Property Let PasswordChar(ByVal New_PasswordChar As String)
    txtText.PasswordChar() = New_PasswordChar
    PropertyChanged "PasswordChar"
End Property

Public Property Get ToolTipText() As String
    ToolTipText = txtText.ToolTipText
End Property

Public Property Let ToolTipText(ByVal New_ToolTipText As String)
    txtText.ToolTipText() = New_ToolTipText
    PropertyChanged "ToolTipText"
End Property

Public Property Get SelText() As String
    SelText = txtText.SelText
End Property

Public Property Let SelText(ByVal New_SelText As String)
    txtText.SelText() = New_SelText
    PropertyChanged "SelText"
End Property

Public Property Get SelStart() As Long
    SelStart = txtText.SelStart - 6 'reduce by six to offset the padding
End Property

Public Property Let SelStart(ByVal New_SelStart As Long)
    txtText.SelStart() = New_SelStart + 6 'add six to account for padding
    PropertyChanged "SelStart"
End Property

Public Property Get SelLength() As Long
    SelLength = txtText.SelLength
End Property

Public Property Let SelLength(ByVal New_SelLength As Long)
    txtText.SelLength() = New_SelLength
    PropertyChanged "SelLength"
End Property

Public Property Get Icon() As Picture
    Set Icon = picIcon.Picture
End Property

Public Property Set Icon(ByVal New_Icon As Picture)
    Set picIcon.Picture = New_Icon
    PropertyChanged "Icon"
End Property
